<template lang="pug">
section
  section.section.is-medium
    div.img-section(v-if="weapon && image")
      div.img-container
        nuxt-img.clickable(:src="`https://tohru.luciascipher.com${image}`" @click="modal = true" :alt="`${weapon.attributes.manufacturer.data.attributes.name} ${weapon.attributes.name}`")
        b-modal(v-model="modal")
          nuxt-img(:src="`https://tohru.luciascipher.com${image}`" :alt="`${weapon.attributes.manufacturer.data.attributes.name} ${weapon.attributes.name}`")
      div.img-belt(v-if="weapon")
        b-button(v-for="(img, ix) in weapon.attributes.images.data" :key="img.id")
          nuxt-img(:src="`https://tohru.luciascipher.com${img.attributes.formats.thumbnail.url}`" @click="image = img.attributes.url" :alt="`${weapon.attributes.name} Image ${ix}`")
    div.product-specs-container
      div.product-specs
        span.productName {{weapon ? weapon.attributes.name: ''}}
        div.brand-container
          span.padded.brand {{$t('manufacturer')}}:
          span.thick.productBrand {{weapon ? weapon.attributes.manufacturer.data.attributes.name : ''}}
        div.calliber-container
          span.padded.calliber {{$t('caliber')}}:
          span.thick.productCalliber {{ weapon ? weapon.attributes.caliber.data.attributes.name : '' }}
        div.type-container
          span.padded.type {{$t('type')}}:
          span.thick.productType {{ $t(`weaponType${weapon ? weapon.attributes.kind.toUpperCase() : ''}`) }}
        div.price-container
          span.price {{$t('price')}}:
          span.thick.productPrice {{ (weapon ? (weapon.attributes.discount_price ? weapon.attributes.discount_price : weapon.attributes.price) : '').toLocaleString() }} #[span.small rsd]
        div.contact-container
          b-button.contact(@click="sendMail()") {{$t('contactBanner')}}
  section.description-container(v-if="weapon && weapon.attributes.description")
    div.description
      p(v-for="line in weapon.attributes.description.split('\\n')") {{line}}
</template>

<script>
export default {
  data() {
    return {
      id: parseInt(this.$route.params.slug.split('-')[0]),
      modal: false,
      weapon: null,
      image: null,
      images: [],
    }
  },
  async fetch() {
    const uri = `https://tohru.luciascipher.com/api/weapons/${this.id}?populate=images,manufacturer,caliber`
    this.weapon = (await (await fetch(uri)).json()).data
    if (this.$i18n.defaultLocale !== this.$i18n.localeProperties.code) {
      this.weapon.attributes.description = this.weapon.attributes[`description_${this.$i18n.localeProperties.code}`]
    }
    this.image = this.weapon.attributes.images.data[0].attributes.url
  },
  head() {
    const sausage = this.$route.params.slug.split('-')
    sausage.splice(0, 1)
    return {
      title: `Dragon Shooting - ${sausage.join(' ').toUpperCase()}`,
    }
  },
  methods: {
    sendMail() {
      const timestamp = Math.floor(new Date().getTime() / 1000)
      const fullName = `${this.weapon.attributes.manufacturer.data.attributes.name} ${this.weapon.attributes.name}`
      const body = this.$t('weaponContact').replace('{%name%}', fullName).replace('{%caliber%}', this.weapon.attributes.caliber.data.attributes.name)
      const uri = `mailto:info@shooting.rs?subject=Dragon Shooting Upit #${timestamp}&body=${body}`
      window.open(uri)
      this.$gtag('event', 'click', {event_category: 'contact', event_label: 'weapon', value: fullName})
    },
  },
}
</script>

<style lang="scss" scoped>
$primary: #006d77;
$bg-grey: #24252a;
$bg-light-grey: #2c3035;
$bg-white-grey: #f7f7f7;
span {
  &.tiny {
    font-size: small;
  }
  &.padded {
    padding-right: 0.5rem;
  }
  &.thick {
    font-weight: 700;
  }
}
.clickable {
  cursor: pointer;
}
.section {
  display: flex;
  justify-content: space-around;
  padding-bottom: 4em;
  .img-section {
    width: 60%;
    height: 100%;
    background-color: $bg-white-grey;

    display: flex;

    flex-direction: row;
    flex-wrap: wrap;
    justify-content: space-around;
    align-items: flex-start;
    .img-container {
      height: 34.5rem;
      width: 50rem;
      display: flex;
      justify-content: center;
      img {
        object-fit: contain;
        max-width: 100%;
      }
    }
  }
  .img-belt {
    width: 100px;
    background-color: $bg-white-grey;
    height: 33.5em;
    button {
      height: auto;
      background-color: transparent;
      margin-bottom: 10px;
    }
  }
  .product-specs-container {
    width: 25%;
    padding-left: 3em;
    padding-top: 2em;
    background-color: $bg-white-grey;
    display: flex;
    flex-direction: row;
    justify-content: flex-start;
    flex-wrap: wrap;
    .product-specs {
      display: flex;
      flex-direction: column;
      align-content: flex-start;
      flex-wrap: wrap;
      justify-content: space-around;
      .brand-container,
      .calliber-container,
      .type-container {
        margin-left: 2em;
      }
      .price-container {
        display: flex;
        justify-content: space-between;
        flex-direction: row;
      }
      .productName,
      .price-container {
        font-size: 24px;
        font-weight: bold;
      }
      .contact-container {
        button {
          width: 20em;
          background-color: $primary;
          color: white;
        }
      }
    }
  }
}
.description-container {
  margin-left: 10em;
  margin-right: 44.6em;
  background-color: #f7f7f7;
  margin-bottom: 3em;
  height: 100%;
  padding-bottom: 2em;
  .description {
    padding-top: 2em;
    padding-left: 2em;
    font-size: 1em;
  }
}
@media only screen and (max-width: 1024px) {
  .section {
    flex-direction: column !important;
    .img-section {
      width: 100% !important;
    }
    .product-specs-container {
      padding-left: 0 !important;
      width: 100% !important;
    }
    .img-container {
      height: 15.5rem !important;
      display: flex;
      justify-content: center;
    }
    .img-belt {
      display: inline-flex !important;
      flex-direction: row !important;
      flex-wrap: nowrap !important;
      justify-content: flex-start !important;
      align-content: flex-start !important;
      height: 8em !important;
      width: 100% !important;
      overflow: scroll;
      img {
        max-width: 4.5em !important;
      }
    }
    .contact.button {
      margin-left: 0.7em !important;
    }
  }
  .description-container {
    margin-left: 1.5em !important;
    margin-right: 0 !important;
    width: 21.5em !important;
    padding-bottom: 2em !important;
    background-color: #f7f7f7 !important;
    height: 100% !important;
    margin-bottom: 2em !important;
  }
}
</style>
